#!/usr/bin/env python2
# Copyright 2007 Robin Gottfried <google@kebet.cz>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# @author Robin Gottfried <google@kebet.cz>
# part of gap project (https://github.com/czervenka/gap)

import webapp2

def as_view(func, methods=['get', 'post']):


    def _handle(self, *args, **kwargs):
        response = func(self.request, self.response, *args, **kwargs)
        if response is not None:
            self.response.write(response)

    class _View(webapp2.RequestHandler):

        for method in methods:
            locals()[method] = _handle

    return _View
